
// SLLinxWatcherDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include "afxcmn.h"
#include <list>
#include <map>

struct sPlayerInfo {
	int m_nRaceID;
	int m_nTrackIndex;
	int m_nBIP;
	TCHAR m_szCountry[5];
	CString m_szFamily;
	CString m_szName;
	int m_nRank;
	int m_nResultMS;
	int m_nDelayMS;
	CString m_szResultComment;
};

// CSLLinxWatcherDlg dialog
class CSLLinxWatcherDlg : public CDialogEx
{
// Construction
public:
	CSLLinxWatcherDlg(CWnd* pParent = NULL);	// standard constructor
	void SaveSettings(CWinApp *pApp);
	void LoadSettings(CWinApp *pApp);

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_SLLINXWATCHER_DIALOG };
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;
	CEdit m_Competion;
	CComboBox m_RaceList;
	CButton m_WatchResult;
	CListCtrl m_PlayerList;
	// local data
	CString m_szSrcLynxEvtPath;
	CString m_szPlayersPath;
	CString m_szSrcResultCsvPath;
	CString m_szDstStartCsvPath;
	CString m_szDstFinishCsvPath;
	CString m_szProjectPath;
	// country map
	std::map<int, std::string> m_nCountryMap;
	// DB data
	enum { eTrackColumn = 0, eRankColumn, eBipColumn, eFamilyColumn, eNameColumn, eTimeColumn, eCountryColumn, eLastColumn };
	std::list<sPlayerInfo> m_Players;
	// Result.csv info
	FILETIME m_ftResultCsv;

protected:
	bool LoadCountryMap();
	bool SaveProject(CString szPath, CString &szError);
	bool LoadProject(CString szPath, CString &szError);
	bool ImportLinx(CString szPath, CString &szError);
	bool ImportPlayers(CString szPath, CString &szError);
	void GetCountry(int id, TCHAR szCountry[5]);
	int GetCurRaceID();
	void FillPlayerList(int nRaceID);
	bool HasResult(int nRaceID);
	bool CheckResultCSV(CString szPath, bool bCheckTime);
	bool SetResultInfo(int nBip, int nRank, int nTimeMS, int nDelayMS, CString szComment);
	bool SaveStartCSV(CString szPath, int nRaceID, CString &szError);
	bool SaveFinishCSV(CString szPath, int nRaceID, CString &szError);
	bool EditInfo(sPlayerInfo & info);
	void RecalcRank(int nRaceID, DWORD &nBestTime);
	void SendTitlerCommand(WPARAM wParam, LPARAM lParam);

public:
	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
	afx_msg void OnBnClickedImport();
	afx_msg void OnBnClickedDb2();
	afx_msg void OnBnClickedWatchPath();
	afx_msg void OnBnClickedStartCsvPath();
	afx_msg void OnBnClickedFinishCsvPath();
	afx_msg void OnBnClickedSaveAll();
	afx_msg void OnBnClickedLoadAll();
	afx_msg void OnCbnSelchangeRace();
	afx_msg void OnBnClickedSaveRace();
	afx_msg void OnBnClickedSaveFinish();
	afx_msg void OnBnClickedWatchResult();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnNMDblclkPlayerList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedExit();
	virtual void OnOK() {}
	virtual void OnCancel() {}
};
