// PlayerInfo.cpp : implementation file
//

#include "stdafx.h"
#include "SLTramplinWatcher.h"
#include "PlayerInfo.h"
#include "afxdialogex.h"


// CPlayerInfo dialog

IMPLEMENT_DYNAMIC(CPlayerInfo, CDialogEx)

CPlayerInfo::CPlayerInfo(CWnd* pParent, sPlayerInfo *info)
	: CDialogEx(IDD_PLAYERINFO, pParent)
{
	m_pInfo = info;
	m_bSelectAsCurrent = false;
}

void CPlayerInfo::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CPlayerInfo, CDialogEx)
	ON_BN_CLICKED(IDC_MAKE_CURRENT, &CPlayerInfo::OnBnClickedMakeCurrent)
END_MESSAGE_MAP()

BOOL CPlayerInfo::OnInitDialog()
{
	CDialogEx::OnInitDialog();
	SetDlgItemInt(IDC_BIP, m_pInfo->m_nNumber);
	SetDlgItemText(IDC_NAME, m_pInfo->m_szName);
	SetDlgItemText(IDC_REGION, m_pInfo->m_szRegion);
	SetDlgItemText(IDC_FLAG, m_pInfo->m_szFlag);
	SetDlgItemInt(IDC_POS, m_pInfo->m_nPos);
	SetDlgItemText(IDC_TCP_NAME, m_pInfo->m_szTCPName);
	SetDlgItemText(IDC_SPEED1, m_pInfo->m_szSpeed[0]);
	SetDlgItemText(IDC_SPEED2, m_pInfo->m_szSpeed[1]);
	SetDlgItemText(IDC_DISTANCE1, m_pInfo->m_szDistance[0]);
	SetDlgItemText(IDC_DISTANCE2, m_pInfo->m_szDistance[1]);
	SetDlgItemText(IDC_REFEREE1_1, m_pInfo->m_szReferee[0 * cRefereeCnt + 0]);
	SetDlgItemText(IDC_REFEREE1_2, m_pInfo->m_szReferee[1 * cRefereeCnt + 0]);
	SetDlgItemText(IDC_REFEREE2_1, m_pInfo->m_szReferee[0 * cRefereeCnt + 1]);
	SetDlgItemText(IDC_REFEREE2_2, m_pInfo->m_szReferee[1 * cRefereeCnt + 1]);
	SetDlgItemText(IDC_REFEREE3_1, m_pInfo->m_szReferee[0 * cRefereeCnt + 2]);
	SetDlgItemText(IDC_REFEREE3_2, m_pInfo->m_szReferee[1 * cRefereeCnt + 2]);
	SetDlgItemText(IDC_REFEREE4_1, m_pInfo->m_szReferee[0 * cRefereeCnt + 3]);
	SetDlgItemText(IDC_REFEREE4_2, m_pInfo->m_szReferee[1 * cRefereeCnt + 3]);
	SetDlgItemText(IDC_REFEREE5_1, m_pInfo->m_szReferee[0 * cRefereeCnt + 4]);
	SetDlgItemText(IDC_REFEREE5_2, m_pInfo->m_szReferee[1 * cRefereeCnt + 4]);
	SetDlgItemInt(IDC_RANK1, m_pInfo->m_nRank[0]);
	SetDlgItemInt(IDC_RANK2, m_pInfo->m_nRank[1]);
	SetDlgItemInt(IDC_SCORE1, m_pInfo->m_nScore[0]);
	SetDlgItemInt(IDC_SCORE2, m_pInfo->m_nScore[1]);
	return TRUE;
}

void CPlayerInfo::OnOK()
{
	m_pInfo->m_nNumber = GetDlgItemInt(IDC_BIP);
	GetDlgItemText(IDC_NAME, m_pInfo->m_szName);
	GetDlgItemText(IDC_REGION, m_pInfo->m_szRegion);
	GetDlgItemText(IDC_FLAG, m_pInfo->m_szFlag);
	m_pInfo->m_nPos = GetDlgItemInt(IDC_POS);
	GetDlgItemText(IDC_TCP_NAME, m_pInfo->m_szTCPName);
	GetDlgItemText(IDC_SPEED1, m_pInfo->m_szSpeed[0]);
	GetDlgItemText(IDC_SPEED2, m_pInfo->m_szSpeed[1]);
	GetDlgItemText(IDC_DISTANCE1, m_pInfo->m_szDistance[0]);
	GetDlgItemText(IDC_DISTANCE2, m_pInfo->m_szDistance[1]);
	GetDlgItemText(IDC_REFEREE1_1, m_pInfo->m_szReferee[0 * cRefereeCnt + 0]);
	GetDlgItemText(IDC_REFEREE1_2, m_pInfo->m_szReferee[1 * cRefereeCnt + 0]);
	GetDlgItemText(IDC_REFEREE2_1, m_pInfo->m_szReferee[0 * cRefereeCnt + 1]);
	GetDlgItemText(IDC_REFEREE2_2, m_pInfo->m_szReferee[1 * cRefereeCnt + 1]);
	GetDlgItemText(IDC_REFEREE3_1, m_pInfo->m_szReferee[0 * cRefereeCnt + 2]);
	GetDlgItemText(IDC_REFEREE3_2, m_pInfo->m_szReferee[1 * cRefereeCnt + 2]);
	GetDlgItemText(IDC_REFEREE4_1, m_pInfo->m_szReferee[0 * cRefereeCnt + 3]);
	GetDlgItemText(IDC_REFEREE4_2, m_pInfo->m_szReferee[1 * cRefereeCnt + 3]);
	GetDlgItemText(IDC_REFEREE5_1, m_pInfo->m_szReferee[0 * cRefereeCnt + 4]);
	GetDlgItemText(IDC_REFEREE5_2, m_pInfo->m_szReferee[1 * cRefereeCnt + 4]);
	m_pInfo->m_nRank[0] = GetDlgItemInt(IDC_RANK1);
	m_pInfo->m_nRank[1] = GetDlgItemInt(IDC_RANK2);
	m_pInfo->m_nScore[0] = GetDlgItemInt(IDC_SCORE1);
	m_pInfo->m_nScore[1] = GetDlgItemInt(IDC_SCORE2);
	CDialogEx::OnOK();
}

void CPlayerInfo::OnBnClickedMakeCurrent()
{
	m_bSelectAsCurrent = true;
	OnOK();
}
