
// SLVolaSplitterDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include "afxcmn.h"


// CSLVolaSplitterDlg dialog
class CSLVolaSplitterDlg : public CDialogEx
{
// Construction
public:
	static const int cMaxClientCnt = 5;
	CSLVolaSplitterDlg(DWORD nServerPort, CString szClientIP[cMaxClientCnt], DWORD nClientPort[cMaxClientCnt]);
	DWORD ServerPort() { return m_nServerPort; }
	CString ClientIP(int nIndex) { return m_szClientIP[nIndex]; }
	DWORD ClientPort(int nIndex) { return m_nClientPort[nIndex]; }
	void ConnectionThread();

#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_SLVOLASPLITTER_DIALOG };
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

private:
	HICON m_hIcon;
	CEdit m_ServerPort;
	CButton m_ServerRun;
	CStatic m_ServerState;
	CIPAddressCtrl m_IPAddress[cMaxClientCnt];
	CEdit m_IPPort[cMaxClientCnt];
	CButton m_IPRun[cMaxClientCnt];
	CEdit m_IPState[cMaxClientCnt];
	//
	DWORD m_nServerPort;
	CString m_szClientIP[cMaxClientCnt];
	DWORD m_nClientPort[cMaxClientCnt];
	//
	SOCKET m_sServerSocket;
	SOCKET m_sVolaSocket;
	WSAEVENT m_hEvent4Connect;
	volatile bool m_bRunning;
	volatile bool m_bSuicide;
	SOCKET m_sClientSocket[cMaxClientCnt];
	// TCP data
	class TCPData {
	public:
		TCPData *m_pNext;
		char *m_pData;
		int m_nSize;
	public:
		TCPData(const char *data, int size) {
			m_pNext = NULL;
			m_pData = new char[size];
			if (m_pData != NULL) {
				CopyMemory(m_pData, data, size);
				m_nSize = size;
			} else  m_nSize = 0;
		}
		~TCPData() { if (m_pData != NULL)  delete[] m_pData;  }
	};
	TCPData *m_pTCPDataHead, *m_pTCPDataTail;
	int m_nTCPPacketCnt;
	int m_nTCPDataSize;

private:
	void Locals2DlgItems();
	void DlgItems2Locals();
	bool InitServer(CString &szError);
	bool StartServer(DWORD nPort, CString &szError);
	void StopAll();
	void ClearVolaData();
	void ClickIPClient(int nIndex);
	bool RunClient(int nIndex);
	bool StartClient(int nIndex, CString szAddress, DWORD nPort, SOCKET& sSocket, CString &szError);
	void StopClient(int nIndex);
	bool CheckVola();
	bool AddVolaData(const char *data, int size);
	bool SendVolaData(SOCKET sSocket, CString &szError);
	void UpdateVolaInfo();
	void UpdateClientInfo(int nIndex);
	void Test();

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg LRESULT OnOpenConnection(WPARAM, LPARAM);
	afx_msg void OnBnClickedRun();
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnBnClickedIpRun1() { ClickIPClient(0); }
	afx_msg void OnBnClickedIpRun2() { ClickIPClient(1); }
	afx_msg void OnBnClickedIpRun3() { ClickIPClient(2); }
	afx_msg void OnBnClickedIpRun4() { ClickIPClient(3); }
	afx_msg void OnBnClickedIpRun5() { ClickIPClient(4); }
	DECLARE_MESSAGE_MAP()
public:
};
